import { Container, Token } from '@ts-phoenix/di';
import { CoreState } from './defs';
import { Package } from './package';
export declare class Core {
    private config;
    private _state;
    private _container;
    private eventManager;
    constructor(config: {
        packages: Array<Package | Package<any, null>>;
    });
    get state(): CoreState;
    get isNew(): boolean;
    get isInitialised(): boolean;
    get isInitialising(): boolean;
    get container(): Container;
    setToken<T>(token: Token<T>, value: T): void;
    private buildPackagesDependencyList;
    initialise(): Promise<void>;
}
