import { Token } from '@ts-phoenix/di';
import { Constructor, DeepPartial } from '@ts-phoenix/typings';
import { Core } from './core';
import { PackageDependency, PartialConfig } from './defs';
export declare abstract class Package<ConfigType extends Record<string, any> | null = null, RequiredConfigType extends Partial<ConfigType> | null = null> {
    protected core: Core;
    protected _config: ConfigType;
    constructor(...args: RequiredConfigType extends null ? [DeepPartial<ConfigType>?] : [RequiredConfigType & DeepPartial<ConfigType>]);
    abstract getConfigToken(): ConfigType extends null ? null : Token<ConfigType>;
    getDependencies(): PackageDependency[];
    getDefaultConfig(): PartialConfig<ConfigType, RequiredConfigType>;
    initialiseServices(): Constructor[];
    get config(): ConfigType;
    protected __setCore(core: Core): void;
    protected __mergeConfig(config: Partial<ConfigType>): void;
    protected __setConfigToken(): void;
}
